package me.km.capabilities;

import net.minecraft.nbt.NBTBase;
import net.minecraft.util.EnumFacing;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.CapabilityInject;
import net.minecraftforge.common.capabilities.ICapabilitySerializable;

public class ChestKeyProvider implements ICapabilitySerializable<NBTBase>
{
    @CapabilityInject(IChestKey.class)
    public static final Capability<IChestKey> CHEST_KEY_CAP = null;

    private final IChestKey instance = CHEST_KEY_CAP.getDefaultInstance();

    @Override
    public boolean hasCapability(Capability<?> capability, EnumFacing facing)
    {
        return capability == CHEST_KEY_CAP;
    }

    @Override
    public <T> T getCapability(Capability<T> capability, EnumFacing facing)
    {
        return capability == CHEST_KEY_CAP ? CHEST_KEY_CAP.<T>cast(this.instance) : null;
    }

    @Override
    public NBTBase serializeNBT()
    {
        return CHEST_KEY_CAP.getStorage().writeNBT(CHEST_KEY_CAP, this.instance, null);
    }

    @Override
    public void deserializeNBT(NBTBase nbt)
    {
        CHEST_KEY_CAP.getStorage().readNBT(CHEST_KEY_CAP, this.instance, null, nbt);
    }
}
