package me.km.chatmanager;

import me.km.KajetansMod;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.api.Utils;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandNickName extends ModuleCommand
{
    public CommandNickName(Module m) 
    {
        super("nickname", m);
        super.setDescription("Gibt einem Spieler einen Nickname");
        super.setUsage("/nickname <nick/clear> [player]");
        super.setPermission(Permissions.NICKNAME);
        super.addAlias("nick");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length < 1)
        {
            return false;
        }
        EntityPlayerMP affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[1]);                   
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[1]));
            return true;
        }
        catch(IndexOutOfBoundsException ex)
        {
            if(!(cs instanceof EntityPlayerMP))
            {
                this.getModule().send(cs, GlobalText.missingParameter());
                return true;
            }
            affectedPlayer = (EntityPlayerMP) cs;
        }
        
        if(arg[0].equals("clear") || arg[0].equals("off"))
        {
            KajetansMod.chatManager.removeNickname(affectedPlayer);
            this.getModule().send(affectedPlayer, "Du hast keinen Nicknamen mehr.");
            if(!cs.equals(affectedPlayer))
            {
                this.getModule().send(cs, affectedPlayer.getName() + " hat keinen Nicknamen mehr.");
            }
            return true;
        }
        KajetansMod.chatManager.setNickname(affectedPlayer, arg[0]);
        this.getModule().send(affectedPlayer, "Du hast nun den Nicknamen '" + arg[0] + "'.");
        if(!cs.equals(affectedPlayer))
        {
            this.getModule().send(cs, affectedPlayer.getName() + " hat nun den Nicknamen '" + arg[0] + "'.");
        }
        return true;
    }
}
