package me.km.commands;

import me.km.api.Utils;
import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandInvSee extends ModuleCommand
{
    public CommandInvSee(Module m) 
    {
        super("invsee", m);
        super.setDescription("Zeigt dir den Inventar eines Spielers");
        super.setUsage("/invsee <player>");
        super.setPermission(Permissions.INVSEE);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        if(arg.length < 1)
        {
            return false;
        }
        EntityPlayerMP p = (EntityPlayerMP) cs;
        try
        {
            p.displayGUIChest(Utils.getPlayerByName(arg[0]).inventory);
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
        }
        return true;
    }
}
