package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import java.util.HashMap;
import me.km.api.Utils;
import me.km.chatmanager.ChatManager;
import me.km.exception.PlayerNotFoundException;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.text.TextComponentString;

public class CommandMsg extends ModuleCommand
{
    protected final HashMap<String, String> answer; 
    
    public CommandMsg(Module m) 
    {
        super("msg", m);
        super.setDescription("Schreibt dem Spieler eine Privatnachricht");
        super.setUsage("/msg <player> <message> oder /r <message>");
        super.setPermission(Permissions.MSG);
        super.addAlias("tell");
        answer = new HashMap<>();
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(arg.length <= 1)
        {
            return false;
        }
        EntityPlayer affectedPlayer;
        try
        {
            affectedPlayer = Utils.getPlayerByName(arg[0]);                   
        }
        catch(PlayerNotFoundException ex)
        {
            this.getModule().send(cs, GlobalText.cantFindPlayer(arg[0]));
            return true;
        }
        String message = ChatManager.colorMessage(Utils.connectSpaces(arg, 1), cs);
        cs.sendMessage(new TextComponentString("§6[ -> §c" + affectedPlayer.getName() + "§6] §r" + message));
        affectedPlayer.sendMessage(new TextComponentString("§6[§c" + cs.getName()+ "§6] §r" + message));
        answer.put(cs.getName(), affectedPlayer.getName());
        answer.put(affectedPlayer.getName(), cs.getName());
        return true;
    }
}
