package me.km.effects.active;

import me.km.api.Utils;
import me.km.effects.ActiveEffectBase;
import me.km.effects.EffectUtils;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.MobEffects;
import net.minecraft.util.DamageSource;

public class LifeBreaker extends ActiveEffectBase
{
    @Override
    protected boolean executeEffect(EntityPlayerMP p, int power) 
    {
        EntityLivingBase liv = Utils.getTargetedEntity(p, 6, EntityLivingBase.class);
        if(liv == null)
        {
            return false;
        }
        Utils.teleportEntity(p, liv);
        
        DamageSource ds = DamageSource.causePlayerDamage(p);
        ds.setDamageIsAbsolute();
        ds.setDamageBypassesArmor();
        liv.attackEntityFrom(ds, p.getMaxHealth() / 5f);
        
        EffectUtils.addPotionTo(liv, MobEffects.SLOWNESS, power * 20, 200);
        EffectUtils.addPotionTo(liv, MobEffects.JUMP_BOOST, power * 20, 128);
        EffectUtils.addPotionTo(liv, MobEffects.WEAKNESS, power * 20, 1);
        return true;
    }
}
