package me.km.entities;

import net.minecraft.client.model.ModelPlayer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;

public class ModelHuman extends ModelPlayer
{
    public ModelHuman(float modelSize, boolean smallArmsIn) 
    {
        super(modelSize, smallArmsIn);
    }
    
    @Override
    public void render(Entity ent, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scale)
    {
        this.setRotationAngles(limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale, ent);
        GlStateManager.pushMatrix();
        
        if(ent.isSneaking())
        {
            GlStateManager.translate(0.0F, 0.2F, 0.0F);
        }

        float factor = ((EntityHuman) ent).getScale();
        GlStateManager.translate(0.0F, -1.5f * factor + 1.5f, 0.0F);
        GlStateManager.scale(factor, factor, factor);
        this.bipedHead.render(scale);
        this.bipedBody.render(scale);
        this.bipedRightArm.render(scale);
        this.bipedLeftArm.render(scale);
        this.bipedRightLeg.render(scale);
        this.bipedLeftLeg.render(scale);
        this.bipedHeadwear.render(scale);
        this.bipedLeftLegwear.render(scale);
        this.bipedRightLegwear.render(scale);
        this.bipedLeftArmwear.render(scale);
        this.bipedRightArmwear.render(scale);
        this.bipedBodyWear.render(scale);

        GlStateManager.popMatrix();
    }
}
