package me.km.items;

import java.util.List;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.World;
import net.minecraftforge.common.capabilities.ICapabilityProvider;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class ItemKey extends ItemBase
{
    private final Item.ToolMaterial toolMaterial;
    
    public ItemKey(String name, String local, Item.ToolMaterial materialIn)
    {
        super(name, local);
        this.toolMaterial = materialIn;
        this.maxStackSize = 1;
    }
    
    public int getLockPickResistance()
    {
        return toolMaterial.getHarvestLevel() + 1;
    }

    @Override
    public ICapabilityProvider initCapabilities(ItemStack stack, NBTTagCompound nbt) 
    {
        getTagCompound(stack);
        return null;
    }  
    
    private static NBTTagCompound getTagCompound(ItemStack stack)
    {
        NBTTagCompound com = stack.getTagCompound();
        if(com == null)
        {
            com = new NBTTagCompound();
            com.setString("chestkey", "");
            com.setBoolean("iscopiedkey", false);
        }
        else 
        {
            if(!com.hasKey("chestkey"))
            {
                com.setString("chestkey", "");  
            }  
            if(!com.hasKey("iscopiedkey"))
            {
                com.setBoolean("iscopiedkey", false);  
            }
        }
        stack.setTagCompound(com);
        return com;
    }
    
    private String getKey(ItemStack stack)
    {
        return getTagCompound(stack).getString("chestkey");
    }
    
    private void setKey(ItemStack stack, String key)
    {
        getTagCompound(stack).setString("chestkey", key);
    } 
    
   private boolean isCopy(ItemStack stack)
    {
        return getTagCompound(stack).getBoolean("iscopiedkey");
    }
    
    private void setCopy(ItemStack stack, boolean copy)
    {
        getTagCompound(stack).setBoolean("iscopiedkey", copy);
    } 
    
    @SideOnly(Side.CLIENT)
    @Override
    public void addInformation(ItemStack stack, World w, List<String> lore, ITooltipFlag flag) 
    {
        if(getKey(stack).isEmpty())
        {
            lore.set(0, TextFormatting.RED + lore.get(0));
        }
        else
        {
            lore.set(0, TextFormatting.GREEN + lore.get(0));
        }
    }
}
