package me.km.items.herbs;

import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.util.SoundCategory;
import net.minecraft.world.World;

public abstract class ItemSpecialHerb extends ItemHerbs
{
    public ItemSpecialHerb(String name, String local) 
    {
        super(name, local);
    }

    @Override
    public final ItemStack onItemUseFinish(ItemStack stack, World w, EntityLivingBase liv)
    {
        if(liv instanceof EntityPlayer)
        {
            EntityPlayer p = (EntityPlayer) liv;
            p.getFoodStats().addStats(this, stack);
            w.playSound(null, p.posX, p.posY, p.posZ, SoundEvents.ENTITY_PLAYER_BURP, SoundCategory.PLAYERS, 0.5F, w.rand.nextFloat() * 0.1F + 0.9F);
            this.onFoodEaten(stack, w, p);
            p.addStat(StatList.getObjectUseStats(this));

            if(p instanceof EntityPlayerMP)
            {
                CriteriaTriggers.CONSUME_ITEM.trigger((EntityPlayerMP) p, stack);
                if(!w.isRemote)
                {
                    onHerbFinish((EntityPlayerMP) p);
                }
            }
        }
        stack.shrink(1);
        return stack;
    }
    
    public abstract void onHerbFinish(EntityPlayerMP p);
}
