package me.km.items.weapons;

import com.google.common.collect.Multimap;
import net.minecraft.entity.ai.attributes.AttributeModifier;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.Item;

public class ItemBattleAxe extends ItemWeapon
{
    private static final AttributeModifier BOOST = new AttributeModifier("extended reach", 0.5d, 0);
    
    public ItemBattleAxe(String name, String local, Item.ToolMaterial material) 
    {
        super(name, local, material, 5, 0.5d);
    }
    
    @Override
    public Multimap<String, AttributeModifier> getItemAttributeModifiers(EntityEquipmentSlot equipmentSlot)
    {
        Multimap<String, AttributeModifier> map = super.getItemAttributeModifiers(equipmentSlot);
        if (equipmentSlot == EntityEquipmentSlot.MAINHAND)
        {
            map.put(EntityPlayer.REACH_DISTANCE.getName(), BOOST);
        }
        return map;
    }
}
