package me.km.items.weapons;

import com.google.common.collect.Multimap;
import net.minecraft.entity.ai.attributes.AttributeModifier;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.EntityEquipmentSlot;

public class ItemSpear extends ItemWeapon
{
    private static final AttributeModifier BOOST = new AttributeModifier("extended reach", 1, 0);
    
    public ItemSpear(String name, String local, ToolMaterial material) 
    {
        super(name, local, material, 6, 0.8d);
    }
    
    @Override
    public Multimap<String, AttributeModifier> getItemAttributeModifiers(EntityEquipmentSlot equipmentSlot)
    {
        Multimap<String, AttributeModifier> map = super.getItemAttributeModifiers(equipmentSlot);
        if (equipmentSlot == EntityEquipmentSlot.MAINHAND)
        {
            map.put(EntityPlayer.REACH_DISTANCE.getName(), BOOST);
        }
        return map;
    }
}
