package me.km.networking;

import io.netty.buffer.ByteBuf;
import java.nio.charset.StandardCharsets;
import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.player.inventory.ContainerLocalMenu;
import net.minecraft.util.text.TextComponentTranslation;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class CampFireInventory implements IMessage
{
    private int windowId;
    private String windowTitle;
    
    public CampFireInventory() 
    {
        windowId = -1;
        windowTitle = "";
    }
    
    public CampFireInventory(int id, String name) 
    {
        windowId = id;
        windowTitle = name;
    }
    
    @Override
    public void fromBytes(ByteBuf buf) 
    {
        windowId = buf.readInt();
        int length = buf.readInt();
        windowTitle = buf.readBytes(length).toString(StandardCharsets.UTF_8);
    }

    @Override
    public void toBytes(ByteBuf buf) 
    {
        buf.writeInt(windowId);
        byte[] b = windowTitle.getBytes(StandardCharsets.UTF_8);
        buf.writeInt(b.length);
        buf.writeBytes(b);
    }

    public static class Handler implements IMessageHandler<CampFireInventory, IMessage>
    {
        @SideOnly(Side.CLIENT)
        @Override
        public IMessage onMessage(CampFireInventory m, MessageContext ctx) 
        {
            Minecraft mc = net.minecraft.client.Minecraft.getMinecraft();
            EntityPlayerSP p = mc.player;
            mc.addScheduledTask(() -> 
            {
                mc.displayGuiScreen(new CampFireInventoryGui(p.inventory, 
                        new ContainerLocalMenu("km:campfire", new TextComponentTranslation(m.windowTitle), 6)));
                p.openContainer.windowId = m.windowId;
            });
            return null;
        }
    }
}
