package me.km.networking;

import io.netty.buffer.ByteBuf;
import me.km.entities.EntityHuman;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.Entity;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class HumanScaleUpdate implements IMessage
{
    private int humanId;
    private float scale;
    private byte slim;
    
    public HumanScaleUpdate() 
    {
        humanId = -1;
        scale = 1;
        slim = 0;
    }
    
    public HumanScaleUpdate(EntityHuman h) 
    {
        humanId = h.getEntityId();
        scale = h.getScale();
        slim = h.getSlim();
    }
    
    @Override
    public void fromBytes(ByteBuf buf) 
    {
        humanId = buf.readInt();
        scale = buf.readFloat();
        slim = buf.readByte();
    }

    @Override
    public void toBytes(ByteBuf buf) 
    {
        buf.writeInt(humanId);
        buf.writeFloat(scale);
        buf.writeByte(slim);
    }

    public static class Handler implements IMessageHandler<HumanScaleUpdate, IMessage>
    {
        @Override
        public IMessage onMessage(HumanScaleUpdate message, MessageContext ctx) 
        {
            Entity ent = Minecraft.getMinecraft().world.getEntityByID(message.humanId);
            if(ent == null || ent.getClass() != EntityHuman.class)
            {
                return null;
            }
            EntityHuman h = (EntityHuman) ent;
            h.setScale(message.scale);
            h.setSlim(message.slim);
            return null;
        }
    }
}
