package me.km.networking;

public enum Icon 
{
    NULL(0, 0, 9, 9),
    FULL_HEART(9, 0, 9, 9),
    HALF_HEART(18, 0, 9, 9),
    EMPTY_HEART(27, 0, 9, 9),
    EMPTY_FOOD(36, 0, 9, 9),
    FULL_FOOD(45, 0, 9, 9),
    EMPTY_ARMOR(54, 0, 9, 9),
    HALF_ARMOR(63, 0, 9, 9),
    FULL_ARMOR(72, 0, 9, 9),
    BUBBLE(81, 0, 9, 9),
    BUBBLE_BROKEN(90, 0, 9, 9),
    FULL_MANA(9, 9, 9, 9),
    HALF_MANA(18, 9, 9, 9),
    EMPTY_MANA(27, 9, 9, 9),
    FULL_THIRST(9, 18, 9, 9),
    HALF_THIRST(18, 18, 9, 9),
    EMPTY_THIRST(27, 18, 9, 9),
    FULL_COLD(9, 27, 9, 9),
    HALF_COLD(18, 27, 9, 9),
    EMPTY_COLD(27, 27, 9, 9),
    FULL_ENERGY(9, 36, 9, 9),
    HALF_ENERGY(18, 36, 9, 9),
    EMPTY_ENERGY(27, 36, 9, 9);
        
    private static Icon[] icons = Icon.values();
            
    private int offsetX;
    private int offsetY;
    private int width;
    private int height;
        
    Icon(int offsetX, int offsetY, int width, int height)
    {
        this.offsetX = offsetX;
        this.offsetY = offsetY;
        this.width = width;
        this.height = height;
    }

    public int getOffsetX() 
    {
        return offsetX;
    }

    public int getOffsetY() 
    {
        return offsetY;
    }

    public int getHeight() 
    {
        return height;
    }

    public int getWidth() 
    {
        return width;
    }
    
    public static Icon getIcon(int i)
    {
        if(i < 0 || i >= icons.length)
        {
            return NULL;
        }
        return icons[i];
    }
}
