package me.km.playerbank;

import java.util.HashMap;
import java.util.UUID;
import me.km.api.Location;
import me.km.api.Module;
import me.km.databank.DataBank;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.text.TextFormatting;

public class PlayerManager extends Module
{
    private final HashMap<UUID, Location> backLocation;
    private final PlayerBank bank;
    
    public PlayerManager(String mname, String prefix, TextFormatting color, DataBank c) 
    {
        super(mname, prefix, color);
        backLocation = new HashMap<>();
        bank = new PlayerBank(this, c);
        super.setDataBank(bank);
    }

    public PlayerBank getDataBank() 
    {
        return bank;
    }
    
    public Location saveLocation(EntityPlayer p)
    {
        return backLocation.put(p.getUniqueID(), new Location(p.world, p.getPositionVector()));
    }
    
    public Location getLastLocation(EntityPlayer p)
    {
        return backLocation.get(p.getUniqueID());
    }
    
    public int getGuildId(String uuid) 
    {
        int i = bank.getTag(uuid, "gilde");
        if(i == 0)
        {
            i = -bank.getIdByUUID(uuid);
        }
        return i;
    }
    
    public int getGuildId(EntityPlayer p) 
    {
        return getGuildId(p.getUniqueID().toString());
    }
    
    public void setGuildId(String uuid, int id) 
    {
        bank.setTag(uuid, "gilde", id);
    }
    
    public void setGuildId(EntityPlayer p, int id) 
    {
        setGuildId(p.getUniqueID().toString(), id);
    }
    
    public boolean getPvpStatus(EntityPlayer p) 
    {
        return bank.getTag(p, "pvp") >= 1;
    }
    
    public void setPvpStatus(EntityPlayer p, boolean b) 
    {
        bank.setTag(p, "pvp", b ? 1 : 0);
    }
}
