package me.km.scoreboard;

import java.util.HashMap;
import java.util.UUID;
import me.km.api.Module;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.util.text.TextFormatting;

public class ScoreboardAPI extends Module
{
    private HashMap<UUID, PlayerScoreboard> boards;
    
    public ScoreboardAPI(String mname, String prefix, TextFormatting color) 
    {
        super(mname, prefix, color);
        boards = new HashMap<>();
    }
    
    public void initScoreboardAPI()
    {
        boards = new HashMap<>();
    }
    
    public void addScoreboard(EntityPlayerMP p)
    {
        boards.put(p.getUniqueID(), new PlayerScoreboard(p));
    }
    
    public void removeScoreboard(UUID uuid)
    {
        boards.remove(uuid);
    }
    
    public PlayerScoreboard getScoreboard(EntityPlayerMP p)
    {
        PlayerScoreboard data = boards.get(p.getUniqueID());
        if(data == null)
        {
            data = new PlayerScoreboard(p);
            boards.put(p.getUniqueID(), data);
            return data;
        }
        return data;
    }
    
    public void resetScoreboard(EntityPlayerMP p)
    {
        getScoreboard(p).clear();
    }
}
