package me.km.skills;

import me.km.effects.EffectCause;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;

public class LeveledSkill 
{
    private byte level;
    private Skill skill;
    
    public LeveledSkill(Skill skill, byte level)
    {
        this.level = level;
        this.skill = skill;
    }
    
    public ItemStack getItemStack()
    {
        return skill.getItemStack(level);
    }
    
    public boolean useEffect(EntityPlayerMP p)
    {
        return skill.getEffect().getEffectInstance().run(p, level, skill.getMana(level), skill.getCooldown(level), EffectCause.SKILL);
    }
    
    public int getId()
    {
        return skill.getId();
    }
}
