package me.km.skills;

import java.util.HashMap;
import me.km.api.Module;
import me.km.effects.Effect;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.TextFormatting;

public class SkillManager extends Module
{
    private final HashMap<Integer, Skill> skills;
    
    public SkillManager(String mname, String prefix, TextFormatting color) 
    {
        super(mname, prefix, color);
        skills = new HashMap<>();
    }
    
    public void registerSkill(int id, ItemStack icon, Effect eff, String name, String explanation,
            int manaConstant, int manaFactor, int cooldownConstant, int cooldownFactor)
    {
        Skill skill = new Skill(id, icon.copy(), eff, name, explanation, manaConstant, manaFactor, cooldownConstant, cooldownFactor);
        if(skills.put(id, skill) == null)
        {
            eff.addSkill(skill);
        }
        else
        {
            throw new NullPointerException("ID '" + id + "' is registered twice.");
        }
    }
    
    public Skill getSkill(int id)
    {
        Skill skill = skills.get(id);
        if(skill == null)
        {
            throw new NullPointerException("ID '" + id + "' has no skill.");
        }
        return skill;
    }
    
    public void clearSkills()
    {
        skills.clear();
        for(Effect c : Effect.values())
        {
            c.clearSkills();
        }
    }
}
